/*
The BonusManager controls the movement of the bonus objects in a level. 
It is responsible from continuous movement of those bonuses while it is not stopped.

The main information pass is with the level class to which this class belongs.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version, modified in the 1.3 version.
*/

import java.util.*;

public class BonusManager extends ManagerTemplate
{
    BonusManager(NormalLevel parLevel){
	  super(parLevel);
	  waitTime=100;
	  Th=new Thread(this);
    }
  
    //starts the motion of the bonuses by starting the run of thread
    public void start(){
	  if(!Th.isAlive())
	       Th.start();
	  else
		 resume();
    }

    //continuously moves the bonuses in the level until it is stopped
    public void run(){
        Bonus nextBonus;
        while(true){
            for (Enumeration e = ((NormalLevel)level).bonuses.elements() ; e.hasMoreElements() ;) {
                nextBonus=((Bonus)e.nextElement());
                nextBonus.move();                
            }
            try{
                level.ownerGame.notifyObserver();
                Th.sleep(waitTime);                            
            }catch(Exception e){System.out.println("Error in bonus control");}
        }
    }
}