/*
The simple bricks that can not move in the game. 
They are hit and terminated by the ball or fire objects. They have different types.

The main information pass is with the level class to which this class belongs.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.awt.image.*;
import symantec.itools.multimedia.*;

public class Brick extends TypedObject
{
    private int strength=1;
    public boolean hasBonus=false;
    protected Bonus bonusOfBrick;
    public static final int TWO_HIT_BROKEN=1, THREE_HIT_BROKEN=0, 
    NORMAL=2, EXPLOSIVE=3, UNBREAKABLE=4, HEIGHT=15, WIDTH=40;
    static String DIRECTORY="Images/Bricks/";
    private Image wholeImage;
    private ImageProducer producer;
    private SoundPlayer soundPlayer1 = new SoundPlayer();
    private SoundPlayer soundPlayer2 = new SoundPlayer();

    Brick(int parX, int parY,int parType,String parHasBonus, Component parOwner, String parImageFile, NormalLevel parLevel){
        super(parX,parY,parOwner,parLevel);        
        try{
            wholeImage=parOwner.getToolkit().getImage(DIRECTORY+parImageFile);
            try {
                MediaTracker tracker = new MediaTracker(owner);
                tracker.addImage(imageOfObject, 0);
                tracker.waitForID(0);
            }catch ( Exception e ) {}
        }
        catch ( Exception e ) {
            System.out.println("Error in reading image file for brick!");
        }
        hasBonus=parHasBonus.equals("true")?true:false;
	  if(((GreetingFrame)level.ownerComponent).isPlayingMusic()){
	  try {
			soundPlayer1.setRepeat(1);
			soundPlayer2.setRepeat(1);
	  }
	  catch(java.beans.PropertyVetoException e) { }
	  try {
				java.net.URL[] tempURL = new java.net.URL[1];
				tempURL[0] = symantec.itools.net.RelativeURL.getURL("sounds/bounce.au");
				soundPlayer1.setURLList(tempURL);
				tempURL[0] = symantec.itools.net.RelativeURL.getURL("sounds/explode.au");
				soundPlayer2.setURLList(tempURL);
		}
	catch (java.net.MalformedURLException error) { }
	catch(java.beans.PropertyVetoException e) { }
	}
        setType(parType);
        setHeight(HEIGHT);
        setWidth(WIDTH);
    }
    
    Brick(int parX, int parY,int parType,String parHasBonus, Component parOwner, String parImageFile){
	  setX(parX);
	  setY(parY);
	  owner=parOwner;
        try{
            wholeImage=parOwner.getToolkit().getImage(DIRECTORY+parImageFile);
            try {
                MediaTracker tracker = new MediaTracker(owner);
                tracker.addImage(imageOfObject, 0);
                tracker.waitForID(0);
            }catch ( Exception e ) {}
        }
        catch ( Exception e ) {
            System.out.println("Error in reading image file for brick!");
        }
        hasBonus=parHasBonus.equals("true")?true:false;
        setType(parType);
        setHeight(HEIGHT);
        setWidth(WIDTH);
    }
    
    public boolean hasBonus(){
        return hasBonus;
    }
    
     public Bonus releaseBonus(){
	  if(hasBonus){
        ((NormalLevel)level).bonuses.addElement(bonusOfBrick);
        level.elements.addElement(bonusOfBrick);
        if(!((NormalLevel)level).bnManager.isAlive())
            ((NormalLevel)level).bnManager.start();
	  return bonusOfBrick;
	  }
	  return null;
    }

    public void setBonus(Bonus parB){
        hasBonus=true;
        bonusOfBrick=parB;
    }

    public void setType(int parType){
        CropImageFilter locCrop;
        type=parType;
        switch(parType){
            case TWO_HIT_BROKEN:
                strength=2;
                locCrop=new CropImageFilter(0,60,50,20);
                break;
            case THREE_HIT_BROKEN:
                strength=3;
                locCrop=new CropImageFilter(0,0,50,20);
                break;
            case UNBREAKABLE:
                strength=-1;
                locCrop=new CropImageFilter(0,140,50,20);
                break;            
            case EXPLOSIVE:
                strength=1;
                locCrop=new CropImageFilter(0,120,50,20);	    
	        break;
            default:
                strength=1;
                locCrop=new CropImageFilter(0,100,50,20);
                break;
        }
        producer = new FilteredImageSource(wholeImage.getSource(), locCrop);
        imageOfObject = owner.createImage(producer); 
        try {
                MediaTracker tracker = new MediaTracker(owner);
                tracker.addImage(imageOfObject, 0);
                tracker.waitForID(0);
        }catch ( Exception e ) {}
    }

    public boolean hit(int parHitStrength){
	  if(((GreetingFrame)level.ownerComponent).isPlayingMusic())
	       soundPlayer1.play();
        CropImageFilter locCrop;
        if(parHitStrength==-1){ 
            level.ownerGame.addScore(250);
            return true;
        }
        if (strength!=-1){
            strength-=parHitStrength;
            if(strength<=0){
                level.ownerGame.addScore(250);
                return true;
            }
            switch(type){
                case TWO_HIT_BROKEN:
                    level.ownerGame.addScore(100);
                    locCrop=new CropImageFilter(0,80,50,20);
                    producer = new FilteredImageSource(wholeImage.getSource(), locCrop);
                    imageOfObject = owner.createImage(producer);        
                    break;
                case THREE_HIT_BROKEN:
                    if(strength==2){
                        level.ownerGame.addScore(50);
                        locCrop=new CropImageFilter(0,20,50,20);
                    }
                    else{
                       level.ownerGame.addScore(100);
                       locCrop=new CropImageFilter(0,40,50,20);
                    }
                    producer = new FilteredImageSource(wholeImage.getSource(), locCrop);
                    imageOfObject = owner.createImage(producer);        
                    break;    
                    
            }
            try {
                MediaTracker tracker = new MediaTracker(owner);
                tracker.addImage(imageOfObject, 0);
                tracker.waitForID(0);
            }catch ( Exception e ) {}
        }
        level.ownerGame.notifyObserver();
        return false;
    }

    public int getXCoor(){
        return (getActualX())/WIDTH;
    }

    public int getYCoor(){
        return (getActualY())/HEIGHT;
    }

    public void terminate(){
        ((NormalLevel)level).bricks.remove(baseOfTerminate());        
        ((NormalLevel)level).checkFinished();
    }

    protected String baseOfTerminate(){
        String xCode,yCode;
        int xCoor=getXCoor(),yCoor=getYCoor();
        if(xCoor<10)
            xCode="0"+xCoor;
        else
            xCode=""+xCoor;
        if(yCoor<10)
            yCode="0"+yCoor;
        else
            yCode=""+yCoor;
        terminate(xCode+yCode);
        return(xCode+yCode);
    }

    protected void terminate(String code){
	    Brick nextBrick;
	    String nextKey;
	    int neighCode[]={1,100,101,-1,-100,-101,99,-99};
	    if(hasBonus){
	        ((NormalLevel)level).bonuses.addElement(bonusOfBrick);
	        ((NormalLevel)level).elements.addElement(bonusOfBrick);
	        releaseBonus();
	    }
	    if(type==EXPLOSIVE){
	     if(((GreetingFrame)level.ownerComponent).isPlayingMusic())
		soundPlayer2.play();
		for(int i=0;i<8;i++){
            nextKey="0000"+(Integer.parseInt(code)+neighCode[i]);
            nextKey=nextKey.substring(nextKey.length()-4, nextKey.length());
            nextBrick=(Brick)((NormalLevel)level).bricks.get(nextKey);
            if(nextBrick!=null)
                nextBrick.terminate();
           }           
        }
       level.elements.removeElement(this);
	}
}