/*
This dialog is used to display properties of a brick.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public class BrickPropertyDialog extends Dialog {

	public BrickPropertyDialog(Frame parent, boolean modal)
	{
		super(parent, modal);
		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(249,178);
		move(150,150);
		setVisible(false);
		bonusLabel.setText("Has Bonus");
		bonusLabel.setAlignment(java.awt.Label.CENTER);
		add(bonusLabel);
		bonusLabel.setBounds(48,24,166,21);
		okButton.setLabel("OK");
		add(okButton);
		okButton.setBackground(java.awt.Color.lightGray);
		okButton.setForeground(java.awt.Color.black);
		okButton.setBounds(96,132,66,27);
		moveLabel.setText("Moving");
		moveLabel.setAlignment(java.awt.Label.CENTER);
		add(moveLabel);
		moveLabel.setBounds(48,48,166,21);
		typeLabel.setText("Normal");
		typeLabel.setAlignment(java.awt.Label.CENTER);
		add(typeLabel);
		typeLabel.setBounds(48,72,166,21);
		fileLabel.setText("File:");
		fileLabel.setAlignment(java.awt.Label.CENTER);
		add(fileLabel);
		fileLabel.setBounds(48,96,166,21);
		setTitle("AWT Application - About");
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		//}}

	}
    
	public BrickPropertyDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
                Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = getParent().getBounds();
    		Rectangle abounds = getBounds();

    		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    			 bounds.y + (bounds.height - abounds.height)/2);
	    }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	Label bonusLabel = new Label();
	Button okButton = new Button();
	Label moveLabel = new Label();
	Label typeLabel = new Label();
	Label fileLabel = new Label();
	//}}
    
    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_ActionPerformed(event);
		}
	}

	protected void okButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		okButton_ActionPerformed_Interaction1(event);
	}


	protected void okButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == BrickPropertyDialog.this)
				BrickPropertyDialog_WindowClosing(event);
		}
	}

	protected void BrickPropertyDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
			 
		BrickPropertyDialog_WindowClosing_Interaction1(event);
	}


	protected void BrickPropertyDialog_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}

}
