/*
The movable fire objects that are managed by the fire manager objects.
They hit and terminate the paddle or bricks. They have different types.

The main information pass is with the level class to which this class belongs.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.awt.image.*;

public class Fire extends TypedObject implements Movable
{
    private Image wholeImage;        
    private Direction direct;
    private static final int waitTime=30;
    private static final String imageFile="Images/Fire.gif";
    public static final int BIG_FIRE=2, SMALL_FIRE=1, LASER=0;

    Fire(int parX, int parY, int parType,Direction parDir, Component parOwner, LevelTemplate parLevel){
        super(parX, parY, parOwner,parLevel);
        direct=parDir;
        try{
            wholeImage=parOwner.getToolkit().getImage(imageFile);
        try {
            MediaTracker tracker = new MediaTracker(owner);
            tracker.addImage(wholeImage, 0);
            tracker.waitForID(0);
        }
        catch ( Exception e ) {}
        }
        catch(Exception e){
            System.out.println("Image file for fire object could not be found! [image/Bonus.gif]");
        }
        setType(parType);        
    }

    public void setType(int parType){
        ImageProducer producer;
        CropImageFilter locCrop;
        type=parType;
        switch(parType){
            case BIG_FIRE:
                locCrop=new CropImageFilter(0,0,29,29);
                setWidth(29);
                setHeight(29);
                break;
            case SMALL_FIRE:
                locCrop=new CropImageFilter(0,32,18,18);
                setWidth(18);
                setHeight(18);
                break;  
            default:
                locCrop=new CropImageFilter(47,0,3,13);
                setWidth(3);
                break;
        }
        producer = new FilteredImageSource(wholeImage.getSource(), locCrop);
        imageOfObject = owner.createImage(producer);
        try {
            MediaTracker tracker = new MediaTracker(owner);
            tracker.addImage(imageOfObject, 0);
            tracker.waitForID(0);
        }
        catch ( Exception e ) {}
    }
    
    public void move(){
        position.x+=direct.x;
        position.y+=direct.y;
        level.handleAction(this);
    }
    
}