/*
The manager class for managing the fire object movements in the given level.

The main information pass is with the level class to which this class belongs.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version, modified in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.util.*;
public class FireManager extends ManagerTemplate
{
    
    FireManager(LevelTemplate parLevel){
        super(parLevel);
    	  waitTime=100;
    }
    public void run(){
        Fire nextFire;
        while(true){
            for (Enumeration e = level.fires.elements() ; e.hasMoreElements() ;) {
                nextFire=((Fire)e.nextElement());
                nextFire.move();                
            }
            try{
                level.ownerGame.notifyObserver();
                Th.sleep(waitTime);                            
            }catch(Exception e){System.out.println("Error in fire control");}
         }
       }
}