/*
The frame on which the game is played.

The main information pass is with the game class thatis being played.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.beans.*;
import java.awt.event.*;


public class GameFrame extends java.awt.Frame 
{
    private Game game;
	symantec.itools.multimedia.SoundPlayer soundPlayer1 = new symantec.itools.multimedia.SoundPlayer();
    
	public GameFrame()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		setSize(600,420);
		setTitle("OO-Ball");
		setBackground(Color.black);
		setResizable(false);
		this.requestFocus();		
		//}}
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
	      SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymKey aSymKey = new SymKey();
		this.addKeyListener(aSymKey);				//}}

		//{{INIT_MENUS
		//}}

	}
    

    
	public GameFrame(Game parGame)
	{
		this();
		game=parGame;		
		parGame.addObserver(this);
		if(((GreetingFrame)game.getOwner()).isPlayingMusic()){
			try {
				soundPlayer1.setRepeat(-1);
			}
			catch(java.beans.PropertyVetoException e) { }
			try {
				java.net.URL[] tempURL = new java.net.URL[1];
				tempURL[0] = symantec.itools.net.RelativeURL.getURL("sounds/music.au");
				soundPlayer1.setURLList(tempURL);
			}
			catch (java.net.MalformedURLException error) { }
			catch(java.beans.PropertyVetoException e) { }
			soundPlayer1.play();
		}
	}
	
	public void paint(Graphics g){
	    game.draw(g);
	}
	public void update(Graphics g){
	    paint(g);
	}
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void gameFinished(boolean parFinished){
		setVisible(false);
		soundPlayer1.stop();
		HighScoreFrame hiSc=new HighScoreFrame((Frame)game.getOwner());
		hiSc.newScore(game.getScore(),game.getName(),parFinished?"Finished":""+(game.getCurrentLevelNo()+1));
		hiSc.show();
	}
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == GameFrame.this)
			GameFrame_WindowClosing(event);
		}
	}

	protected void GameFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		soundPlayer1.stop();
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}
		class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == GameFrame.this)
				gameFrame_MouseClicked(event);
		}
	}

	protected void gameFrame_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		gameFrame_MouseClicked_Interaction1(event);
	}

	protected void gameFrame_MouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
			game.startAction();
		
	}
    class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == GameFrame.this)
				gameFrame_MouseMoved(event);
		}
	}

	protected void gameFrame_MouseMoved(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		gameFrame_MouseMoved_Interaction1(event);
	}

	protected void gameFrame_MouseMoved_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
	        game.movePaddle(event.getPoint());
	        repaint();
		} catch (Exception e) {
		}
	}
	class SymKey extends java.awt.event.KeyAdapter
	{
		public void keyPressed(java.awt.event.KeyEvent event)
		{
				this_KeyPressed(event);
		}
	}

	protected void this_KeyPressed(java.awt.event.KeyEvent event)
	{
			 
		this_KeyPressed_Interaction1(event);
	}

	protected void this_KeyPressed_Interaction1(java.awt.event.KeyEvent event)
	{
		try {
			int code=event.getKeyCode();
			if(code==KeyEvent.VK_UP)
				game.movePaddle(0,-10);
			else if(code==KeyEvent.VK_DOWN)
				game.movePaddle(0,10);
			else if(code==KeyEvent.VK_LEFT)
				game.movePaddle(-10,0);
			else if(code==KeyEvent.VK_RIGHT)		
				game.movePaddle(10,0);
			else if(code==KeyEvent.VK_SPACE)
				game.startAction();					
			else if(code==KeyEvent.VK_ESCAPE){
				RUSureDialog rus=new RUSureDialog(this);
				rus.setModal(true);
				rus.show();
				if(rus.isAccepted())
					game.lostGame();				
			}

		} catch (Exception e) {
		}
	}
}