/*
The dialog used to select a new game to play.

The main information pass is with the greeter class 
which keeps the information about the new game to be played.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.1 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public class GameSelectDialog extends Dialog
{
    private GreetingFrame greeter;
    private String gameList[][];
	public GameSelectDialog(Frame parent)
	{
		super(parent);
		greeter=(GreetingFrame)parent;
		setTitle("Select Your Game");
		setBackground(Color.black);
		setForeground(Color.green);
		setLayout(null);
		setSize(400,270);
		setVisible(false);
		add(gmList);
		gmList.setBackground(Color.white);
		gmList.setForeground(Color.black);
		gmList.setBounds(50,60,300,164);
		OKButton.setLabel("OK");
		add(OKButton);
		OKButton.setForeground(Color.black);
		OKButton.setBackground(java.awt.Color.lightGray);
		OKButton.setBounds(120,240,55,20);
		CancelButton.setLabel("Cancel");
		add(CancelButton);
		CancelButton.setForeground(Color.black);
		CancelButton.setBackground(java.awt.Color.lightGray);
		CancelButton.setBounds(228,240,55,20);
		gmLb.setText("Game List:");
		add(gmLb);
		gmLb.setBounds(48,36,236,18);
		gameList=FileManager.getGameList();
		int noOfGames=gameList.length;
		for(int i=0; i<noOfGames;i++){
		    gmList.addItem("Game: "+gameList[i][1]+" with "+gameList[i][2]+" level(s)");
		}
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		OKButton.addActionListener(lSymAction);
		CancelButton.addActionListener(lSymAction);
		//}}
	}

	public GameSelectDialog()
	{
		this((Frame)null);
	}

	public GameSelectDialog(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.List gmList = new java.awt.List(0);
	java.awt.Button OKButton = new java.awt.Button();
	java.awt.Button CancelButton = new java.awt.Button();
	java.awt.Label gmLb = new java.awt.Label();
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == OKButton)
				OKButton_ActionPerformed(event);
			else if (object == CancelButton)
				CancelButton_ActionPerformed(event);
		}
	}

	protected void OKButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		OKButton_ActionPerformed_Interaction1(event);
	}

	protected void OKButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
	        greeter.setGame(gameList[gmList.getSelectedIndex()][0],gameList[gmList.getSelectedIndex()][1]);
	        setVisible(false);
		} catch (Exception e) {
		}
	}

	protected void CancelButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		CancelButton_ActionPerformed_Interaction1(event);
	}

	protected void CancelButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
	        setVisible(false);
		} catch (Exception e) {
		}
	}
}