/*
The greeter frame which offers a menu having the options:
	Play Game 
	Select Your Game
	Game Editor
	Top Ten Scorings
	Settings
	Exit

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import symantec.itools.multimedia.*;

public class GreetingFrame extends Frame
{
	private Game newGame;
	private String gameFileName="default.gm";
	Button startButton = new Button();
	Button settingsButton = new Button();
	Button exitButton = new Button();	
	Button editorButton = new Button();
	Button chGameButton = new Button();
	Button highScoresButton = new Button();
	ImageViewer imageViewer1 ; 
	Label gameLb = new Label();
	Label gmNameLb = new Label();
   	private Color bckColor=Color.black;
    	private Image bckImage=null;
    	private boolean playMusic=true;    

		
	public GreetingFrame()
	{
		setLayout(null);
		setBackground(java.awt.Color.black);
		setSize(236,300);
		setVisible(false);
		move(150,150);
		editorButton.setLabel("Game Editor");
		add(editorButton);
		editorButton.setBackground(java.awt.Color.lightGray);
		editorButton.setBounds(0,228,118,36);
		highScoresButton.setLabel("High Scores");
		add(highScoresButton);
		highScoresButton.setBackground(java.awt.Color.lightGray);
		highScoresButton.setBounds(118,228,118,36);
		settingsButton.setLabel("Settings");
		add(settingsButton);
		settingsButton.setBackground(java.awt.Color.lightGray);
		settingsButton.setBounds(0,264,118,36);
		exitButton.setLabel("Exit");
		add(exitButton);
		exitButton.setBackground(java.awt.Color.lightGray);
		exitButton.setBounds(118,264,118,36);
		chGameButton.setLabel("Change Game");
		add(chGameButton);
		chGameButton.setBackground(java.awt.Color.lightGray);
		chGameButton.setBounds(118,192,118,36);
		startButton.setLabel("Start New Game");
		add(startButton);
		startButton.setBackground(java.awt.Color.lightGray);
		startButton.setBounds(0,192,118,36);
		try {
			imageViewer1=new ImageViewer(getToolkit().getImage("Images/oo-ball.gif"));
		}
		catch (Exception e) { }
		try {
			imageViewer1.setStyle(symantec.itools.multimedia.ImageViewer.IMAGE_SCALED_TO_FIT);
		}
		catch(java.beans.PropertyVetoException e) { }
		add(imageViewer1);
		imageViewer1.setBounds(4,0,228,192);
		setTitle("Welcome To OO-Ball");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		startButton.addActionListener(lSymAction);
	      chGameButton.addActionListener(lSymAction);
	      editorButton.addActionListener(lSymAction);
      	highScoresButton.addActionListener(lSymAction);
      	settingsButton.addActionListener(lSymAction);
		exitButton.addActionListener(lSymAction);

	}
    
	public boolean isPlayingMusic(){
		return playMusic;
	}

	public void setPlayMusic(boolean parM){
		playMusic=parM;
	}
	public Color getBckColor(){
		return bckColor;
	}

	public void setBckImage(Image parImage){
		bckImage=parImage;
	}
	public Image getBckImage(){
		return bckImage;
	}

	public void setBckColor(Color parColor){
		bckColor=parColor;
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == GreetingFrame.this)
				GreetingFrame_WindowClosing(event);
		}
	}
	
	protected void GreetingFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
		
	}
		class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == startButton)
				startButton_ActionPerformed(event);
		    else if(object==chGameButton)
		        chGameButton_ActionPerformed(event);
		    else if(object==highScoresButton)
		        highScoresButton_ActionPerformed(event);
		    else if(object==settingsButton)
		        settingsButton_ActionPerformed(event);
		    else if(object==editorButton)
		        editorButton_ActionPerformed(event);
		    else if(object==exitButton)
		        exitButton_ActionPerformed(event);
		}
	}
    	protected void setGame(String parGameFileName, String parGameName){
	  gameFileName=parGameFileName;
        gmNameLb.setText(parGameName);
    	}
	protected void startButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		startButton_ActionPerformed_Interaction1(event);
	}
	protected void exitButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		setVisible(false);
			 
		
	}
	protected void editorButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		editorButton_ActionPerformed_Interaction1(event);
	}
	protected void settingsButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		settingsButton_ActionPerformed_Interaction1(event);
	}
	protected void highScoresButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		highScoresButton_ActionPerformed_Interaction1(event);
	}
    protected void chGameButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		chGameButton_ActionPerformed_Interaction1(event);
	}

	protected void startButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	        FileManager.getGameList();
	       	newGame=new Game(this,gameFileName);
		    newGame.initialize();
		    GameFrame gmFr=new GameFrame(newGame);
	        setVisible(false);
	        gmFr.show();	
	}
    protected void chGameButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	        GameSelectDialog gmSl=new GameSelectDialog(this);
	        gmSl.show();	
	}
    protected void highScoresButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	        HighScoreFrame hiSc=new HighScoreFrame();
	        hiSc.show();	
	}
    protected void settingsButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	        SettingsDialog setD=new SettingsDialog(this);
	        setD.show();	
	}
	protected void editorButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	        GameEditorDialog editG=new GameEditorDialog(this);
	        editG.show();	
	}

} 