/*
The high scores play which displays the current high scores.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.beans.*;

public class HighScoreFrame extends java.awt.Frame
{
    private String scores[][];
	Label labels[][]=new Label[11][5];
	private Frame nextFrame=null;
	public HighScoreFrame(Frame parFr){
		this();
		nextFrame=parFr;			
	}
	public HighScoreFrame()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(400,300);
		setBackground(Color.black);
		setForeground(Color.green);
		lbTitle.setText("High Scores");
		lbTitle.setAlignment(java.awt.Label.CENTER);
		add(lbTitle);
		lbTitle.setForeground(java.awt.Color.blue);
		lbTitle.setFont(new Font("Dialog", Font.BOLD, 12));
		lbTitle.setBounds(12,12,374,21);
		setTitle("Top Ten Scorings");
		setResizable(false);
		//}}
        getScores(); 
        labels[0][0]=new Label("Rank");
        labels[0][0].setBounds(12,34,40,20);
	  labels[0][0].setForeground(Color.white);
	  add(labels[0][0]);
		labels[0][1]=new Label("Name");
        labels[0][1].setBounds(52,34,100,20);
	  labels[0][1].setForeground(Color.white);
	  add(labels[0][1]);
		labels[0][2]=new Label("Game");
	  labels[0][2].setForeground(Color.white);
        labels[0][2].setBounds(152,34,100,20);
	  add(labels[0][2]);
		labels[0][3]=new Label("Level");
	  labels[0][3].setForeground(Color.white);
        labels[0][3].setBounds(252,34,80,20);
	  add(labels[0][3]);
		labels[0][4]=new Label("Score");
        labels[0][4].setBounds(332,34,80,20);
	  labels[0][4].setForeground(Color.white);
	  add(labels[0][4]);
		for (int i=1;i<11;i++){
		   for (int j=0;j<5;j++){
		        labels[i][j]=new Label(scores[i-1][j]);
			  switch(j){
			  case 0:
				  labels[i][j].setBounds(12,34+i*20,40,20);
				  break;
			  case 1:
				  labels[i][j].setBounds(52,34+i*20,100,20);
				  break;
			  case 2:
				  labels[i][j].setBounds(152,34+i*20,100,20);
				  break;
			  case 3:	
				  labels[i][j].setBounds(252,34+i*20,80,20);
				  break;
			  case 4:
				  labels[i][j].setBounds(332,34+i*20,80,20);
				  break;
			  }		    
		        add(labels[i][j]);
		   }
		}
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}

		//{{INIT_MENUS
		//}}
	}

	public HighScoreFrame(String title)
	{
		this();
		setTitle(title);
	}
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == HighScoreFrame.this)
			HighScoreFrame_WindowClosing(event);
		}
	}

	protected void HighScoreFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
		if(nextFrame!=null)
			nextFrame.show();
	}
	//{{DECLARE_CONTROLS
	java.awt.Label lbTitle = new java.awt.Label();
	//}}

	//{{DECLARE_MENUS
	//}}
   public boolean newScore(int parScore, String parGameName, String parLevel){
	if(parScore>=Integer.parseInt(scores[9][4]))
		addNewScore(parScore, parGameName, parLevel);
	else
		return false;
	return true;
   }
   protected void getScores(){
            scores=FileManager.getHighScores(10,5);
    }
    private void addNewScore(int parScore, String parGameName, String parLevel){
		int i=0;
		while(i<=9&&parScore>=Integer.parseInt(scores[9-i][4])){
			for(int j=1;j<5 && i<9;j++)
				scores[9-i][j]=scores[8-i][j];
			i++;
		}
		i--;
		scores[9-i][4]=""+parScore;
		scores[9-i][3]=parLevel;
		scores[9-i][2]=parGameName;
		scores[9-i][1]=getPlayerName();
		setScores();
    }
    private void setScores(){
	for (int i=1;i<11;i++){
		   for (int j=0;j<5;j++){
		        labels[i][j].setText(scores[i-1][j]);
		   }
		}
	FileManager.setHighScores(scores);
    }
    
    private String getPlayerName(){
	PlayerNameDialog plName=new PlayerNameDialog(this,true);
	plName.show();
	return plName.getUserName();
    }
}