/*
The level editor frame to form custom levels.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.util.*;
import symantec.itools.awt.ImageListBox;
import java.awt.image.*;

public class LevelEditorFrame extends Frame
{
    private String imageFiles[];    
    int currentFileNo=0;
    private Hashtable bricks=new Hashtable();
    private boolean deleteMode=false;
    private boolean propMode=false;
    private String[] tempString = new String[5];
				
    public LevelEditorFrame()
    {
		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(600,460);
		setVisible(false);
		panel.setLayout(null);
		add(panel);
		imageFiles=FileManager.getBrickList();
		panel.setBounds(480,20,112,374);
		try {
			brickLB.setBorderType(symantec.itools.awt.ImageListBox.BORDER_NONE);
		}
		catch(java.beans.PropertyVetoException e) { }
				setImageList(imageFiles[0]);				
		panel.add(brickLB);
		brickLB.setBackground(java.awt.Color.lightGray);
		brickLB.setBounds(0,36,96,144);
		brickHB.setBlockIncrement(1);
		brickHB.setMaximum(imageFiles.length);
		panel.add(brickHB);
		brickHB.setBounds(0,192,96,15);
		add(drawingCanvas);
		drawingCanvas.setForeground(Color.white);
		drawingCanvas.setBounds(10,30,450,400);
		drawingCanvas.setBackground(Color.white);
		movingCheck.setLabel("Moving");
		panel.add(movingCheck);
		movingCheck.setBounds(0,220,78,16);
		hasBonusCheck.setLabel("Has Bonus");
		panel.add(hasBonusCheck);
		hasBonusCheck.setBounds(0,240,81,17);
		hasMonstersCheck.setLabel("Has Monsters");
		panel.add(hasMonstersCheck);
		hasMonstersCheck.setBounds(0,300,90,17);
		newLb.setText("New Brick");
		newLb.setAlignment(java.awt.Label.CENTER);
		panel.add(newLb);
		newLb.setBounds(0,12,81,18);
		setTitle("Level Editor");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		editorMenu.setLabel("File");
		editorMenu.add(saveMI);
		saveMI.setLabel("Save");
		editorMenu.add(newMI);
		newMI.setLabel("New");
		editorMenu.add(closeMI);
		closeMI.setLabel("Close");
		mnBar.add(editorMenu);
		brickMenu.setLabel("Brick");
		brickMenu.add(delMI);
		insMI.setLabel("Insert");
		brickMenu.add(insMI);
		delMI.setLabel("Delete");
		brickMenu.add(propMI);
		propMI.setLabel("Properties");
		mnBar.add(brickMenu);
		//$$ mnBar.move(12,360);
		//$$ menuBar1.move(24,48);
		setMenuBar(mnBar);
		//}}
      
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		drawingCanvas.addMouseListener(aSymMouse);
		//
		SymAdjustment lSymAdjustment = new SymAdjustment();
		brickHB.addAdjustmentListener(lSymAdjustment);
		SymAction lSymAction = new SymAction();
		saveMI.addActionListener(lSymAction);
		closeMI.addActionListener(lSymAction);
		newMI.addActionListener(lSymAction);
		delMI.addActionListener(lSymAction);
		propMI.addActionListener(lSymAction);
		insMI.addActionListener(lSymAction);
	}

	public LevelEditorFrame(String title)
	{
		this();
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}


	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	Panel panel = new Panel();
	symantec.itools.awt.ImageListBox brickLB = new symantec.itools.awt.ImageListBox();
	java.awt.Scrollbar brickHB = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,0,10);
	Checkbox movingCheck = new Checkbox();
	Checkbox hasBonusCheck = new Checkbox();
	Checkbox hasMonstersCheck = new Checkbox();
	Label newLb = new Label();
	Canvas drawingCanvas = new Canvas();
	//}}

	//{{DECLARE_MENUS
	MenuBar mnBar = new MenuBar();
	Menu editorMenu = new Menu();
	MenuItem saveMI = new MenuItem();
	MenuItem newMI = new MenuItem();
	MenuItem closeMI = new MenuItem();
	MenuItem insMI = new MenuItem();
	Menu brickMenu = new Menu();
	MenuItem delMI = new MenuItem();
	MenuItem propMI = new MenuItem();

	//}}
	private void setImageList(String parFileName){
        Image wholeImage;
        Image images[]=new Image[5];
        CropImageFilter locCrop[]=new CropImageFilter[5];
        ImageProducer producer;
        try{
		  brickLB.delItems(0,4);
            wholeImage=getToolkit().getImage(Brick.DIRECTORY+parFileName);
            try {
                MediaTracker tracker = new MediaTracker(this);
                tracker.addImage(wholeImage, 0);
                tracker.waitForID(0);
            }catch ( Exception e ) {}        
    			tempString[0] = "3-Hit";
				tempString[1] = "2-Hit";
				tempString[2] = "Normal";
				tempString[3] = "Explosive";
				tempString[4] = "Unbreakable";
	          locCrop[0]=new CropImageFilter(0,0,50,20);
                locCrop[1]=new CropImageFilter(0,60,50,20);
                locCrop[2]=new CropImageFilter(0,100,50,20);
                locCrop[3]=new CropImageFilter(0,120,50,20);	    
                locCrop[4]=new CropImageFilter(0,140,50,20);
                for(int i=0;i<5;i++){
                    producer = new FilteredImageSource(wholeImage.getSource(), locCrop[i]);
                    images[i] = createImage(producer); 
                    try {
                        MediaTracker tracker = new MediaTracker(this);
                        tracker.addImage(images[i], 0);
                        tracker.waitForID(0);
                    }catch ( Exception e ) {}
                    brickLB.addItem(images[i], tempString[i]);
                }
                }catch ( Exception e ) {
                        System.out.println("Error in reading image file for editor!");
                }
       }
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == LevelEditorFrame.this)
				LevelEditorFrame_WindowClosing(event);
		}
	}
	
	protected void LevelEditorFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}
	public void paint(Graphics g){
		drawingCanvas.getGraphics().fillRect(0,0,450,400);
		for (Enumeration e = bricks.elements() ; e.hasMoreElements() ;) {
		    ((GeneralBrick)e.nextElement()).draw(drawingCanvas.getGraphics());             
		}		
	}
	
	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			this_MouseClicked(event);
		}
	}

	protected void this_MouseClicked(java.awt.event.MouseEvent event)
	{
			 
		MouseClicked_Interaction1(event);
	}

	protected void MouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
			if(event.getY()>200)
				return;
			String key;
			int xCoor=event.getX()/Brick.WIDTH;
			int yCoor=event.getY()/Brick.HEIGHT;
			if(yCoor<10)
				key="0"+yCoor;
			else
				key=""+yCoor;
			if(xCoor<10)
				key="0"+xCoor+key;
			else
				key=xCoor+key;
			if(deleteMode){
				bricks.remove(key);
			}
			else if(propMode){
				showProperties((GeneralBrick)bricks.get(key));
			}
			else
				bricks.put(key,new GeneralBrick(xCoor*Brick.WIDTH,yCoor*Brick.HEIGHT,brickLB.getSelectedIndex(),hasBonusCheck.getState()?"true":"false",this,imageFiles[currentFileNo],movingCheck.getState()));	
			repaint();
	}

		private class GeneralBrick extends Brick{
			boolean moving;
			String imageFileName;
			 GeneralBrick(int parX, int parY,int parType,String parHasBonus, Component parOwner, String parImageFile, boolean parMoving){
				super(parX, parY,parType,parHasBonus, parOwner, parImageFile);
				imageFileName=parImageFile;
				moving=parMoving;	
			}
			public boolean isMoving(){
				return moving;
			}
		}
		class SymAdjustment implements java.awt.event.AdjustmentListener
		{
			public void adjustmentValueChanged(java.awt.event.AdjustmentEvent event)
			{
				setImageList(imageFiles[currentFileNo=brickHB.getValue()]);
			}
		}
		class SymAction implements java.awt.event.ActionListener
		{
			public void actionPerformed(java.awt.event.ActionEvent event)
			{
					Object object = event.getSource();
				if (object == saveMI)
					saveMI_ActionPerformed(event);
				else if (object == closeMI)
					closeMI_ActionPerformed(event);
				else if (object == newMI)
					newMI_ActionPerformed(event);
				else if (object == delMI)
					delMI_ActionPerformed(event);
				else if (object == propMI)
					propMI_ActionPerformed(event);
				else if (object == insMI)
					insMI_ActionPerformed(event);
			}
		}
	
		protected void saveMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			 
			saveMI_ActionPerformed_Interaction1(event);
		}	
		protected void delMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			deleteMode=true;			 
			propMode=false;
			setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));		
		}	
		protected void insMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			deleteMode=false;
			propMode=false;			 
			setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));		
			
		}	
		protected void propMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			 propMode=true;
			deleteMode=false;			
			setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));		
		}	
		protected void closeMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			setVisible(false);			 
		}	
		protected void newMI_ActionPerformed(java.awt.event.ActionEvent event)
		{
			bricks.clear();
			repaint();
		}	

		protected void saveMI_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
		{
			String strList[]=new String[4+bricks.size()];
			SaveLevelDialog slName=new SaveLevelDialog(this,true);
			slName.show();
			if(slName.isCanceled())
				return;
			strList[0]=slName.getFileName()+".lv";
			strList[1]="Normal";
			strList[2]=slName.getLevelName();
			strList[3]=hasMonstersCheck.getState()?"true":"false";
			Enumeration e = bricks.keys() ;
			GeneralBrick nextGB;
			String nextKey;
			for(int i=4;i<strList.length;i++){
				nextKey=((String)e.nextElement());				
				nextGB=(GeneralBrick)bricks.get(nextKey);
				strList[i]=nextKey.substring(0,2)+","+nextKey.substring(2,4)+","+(nextGB.moving?"true":"false")+","+nextGB.getType()+","+(nextGB.hasBonus?"true":"false")+","+nextGB.imageFileName;             
			}
			FileManager.saveLevel(strList);
		}
		private void showProperties(GeneralBrick parB){
			if(parB==null)
				return;
			BrickPropertyDialog bpName=new BrickPropertyDialog(this,true);
			if(!parB.hasBonus())
				bpName.bonusLabel.setText("No Bonus");
			if(!parB.isMoving())
				bpName.moveLabel.setText("Not Moving");
			bpName.typeLabel.setText(tempString[parB.getType()]);
			bpName.fileLabel.setText("File: "+parB.imageFileName);			
			bpName.show();
		}
	}

