/*
The base class for the manager classes which manage the movable objects in the game.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.util.*;

public abstract class ManagerTemplate implements Runnable
{
    protected LevelTemplate level;
    protected Thread Th;
    protected int waitTime;
    
    ManagerTemplate(LevelTemplate parLevel){
        level=parLevel;
    }
    
    public void start(){
        Th=new Thread(this);
        Th.start();
    }
    public void resume(){
        Th.resume();
    }
    public void suspend(){
        Th.suspend();
    }
    public boolean isAlive(){
        return Th.isAlive();
    }

    public void stop(){
        Th.stop();
    }
    
    public abstract void run();
}