/*
The level that includes a boss monster as the main element.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.1 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public class MonsterLevel extends LevelTemplate
{
    protected BossMonster boss;
    
    MonsterLevel(Component parOwnerComponent, Game parOwnerGame){
        super(parOwnerComponent, parOwnerGame);
        boss=new BossMonster(100, 100, parOwnerComponent, this);        
        elements.addElement(boss);        
    }
    public void start(){
        boss.start();
        bManager.start();
        fManager.start();
    }
    public void death(){
        boss.suspend();
        super.death();
	  ownerGame.notifyObserver();     
    }
    public void finish(){        
        boss.stop();
        boss.finalize();
        super.finish();
    }
    public void handleAction(Ball parB){
        ownerGame.getActionManager().ballMotion(this,parB);
    }
    public void handleAction(Fire parF){
        ownerGame.getActionManager().fireMotion(this,parF);
    }    
    public void handleAction(BossMonster parB){
        ownerGame.getActionManager().bossMotion(this,parB);
    }
}