/*
The manager that manages the movements of the monsters in a level.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version, modified in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.util.*;

public class MonsterManager extends ManagerTemplate
{
    static int SLOW=1, FAST=0;
    private int noOfTimes=0;
    
    MonsterManager(NormalLevel parLevel){
        super(parLevel);
	  waitTime=100;
    }
    public void setSpeed(int parSpeed){
        if(parSpeed==SLOW)
            waitTime=150;
        else
            waitTime=50;
    }
    public void run(){
        Monster nextMonster;
        while(true){
	           noOfTimes++;
            if(noOfTimes==100){
                noOfTimes=0;
                ((NormalLevel)level).addMonster();
            }
            for (Enumeration e = ((NormalLevel)level).monsters.elements() ; e.hasMoreElements() ;) {
                nextMonster=((Monster)e.nextElement());
                nextMonster.move();                
            }
            try{
                level.ownerGame.notifyObserver();
                Th.sleep(waitTime);                            
            }catch(Exception e){System.out.println("Error in monster control");}
        }
      
    }
}