/*
The moving brick that has the property to move and has different types.
It is basically a special type of brick class.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.1 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public class MovingBrick extends Brick implements Movable
{
    static final int HORIZONTAL_DISPLACEMENT=5;    
    private static final int waitTime=100;
    private boolean toRight=true;
    
    MovingBrick(int parX, int parY,int parType, String parHasBonus, Component parOwner, String parImageFile, NormalLevel parLevel){
        super(parX, parY,parType, parHasBonus, parOwner, parImageFile, parLevel);        
    }
    public void terminate(){
        ((NormalLevel)level).mvBricks.removeElement(this);       
        super.baseOfTerminate();
        ((NormalLevel)level).checkFinished();
        
    }
    public void move(){
        if(toRight)
            position.x+=HORIZONTAL_DISPLACEMENT;
        else
            position.x-=HORIZONTAL_DISPLACEMENT;
        ((NormalLevel)level).handleAction(this);
	  if(hasBonus){
        	bonusOfBrick.position.x=position.x;
        	bonusOfBrick.position.y=position.y;
	  }
    }
    public boolean isMovingToRight(){
	return toRight;
    }    
    public void changeDirectionToRight(boolean parToRight){
        toRight=parToRight;
    }
}