/*
The dialog used to get the player name of the user who can enter the high scores list.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

import symantec.itools.awt.util.dialog.ModalDialog;

public class PlayerNameDialog extends ModalDialog
{
    
    private HighScoreFrame owner;
	public PlayerNameDialog(Frame parent, String title)
	{
		super(parent, title);
        owner=(HighScoreFrame)parent;
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(215,130);
		setVisible(false);
		nameLabel.setText("Name:");
		add(nameLabel);
		nameLabel.setBounds(12,60,75,15);
		add(userTextField);
		userTextField.setBackground(java.awt.Color.white);
		userTextField.setBounds(96,60,100,22);
		userTextField.setForeground(java.awt.Color.black);
		okButton.setLabel("OK");
		add(okButton);
		okButton.setBackground(java.awt.Color.lightGray);
		okButton.setForeground(java.awt.Color.black);
		okButton.setBounds(84,96,52,25);
		conLb.setText("Congratulations!");
		conLb.setAlignment(java.awt.Label.CENTER);
		add(conLb);
		conLb.setForeground(java.awt.Color.cyan);
		conLb.setFont(new Font("Dialog", Font.BOLD, 12));
		conLb.setBounds(12,12,180,31);
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		//}}
	}
	
	public PlayerNameDialog(Frame parent)
	{
		this(parent, "Player Name");
	}

	// Add a constructor for Interactions (ignoring modal)
	public PlayerNameDialog(Frame parent, boolean modal)
	{
		this(parent);
	}

	// Add a constructor for Interactions (ignoring modal)
	public PlayerNameDialog(Frame parent, String title, boolean modal)
	{
		this(parent, title);
	}

	public String getUserName()
	{
		return userTextField.getText();
	}

	
	public void setUserName(String name)
	{
		userTextField.setText(name);
	}

	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	Label nameLabel = new Label();
	TextField userTextField = new TextField();
	Button okButton = new Button();
	Label conLb = new Label();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_ActionPerformed(event);
		}
	}

	protected void okButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		okButton_ActionPerformed_Interaction1(event);
	}

	protected void okButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
            setVisible(false);
		} catch (Exception e) {
		}
	}
}
