/*
This ddialog asks whether or not the player wants to quit the game.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public class RUSureDialog extends Dialog
{
	private boolean accepted=false;
	public RUSureDialog(Frame parent)
	{
		super(parent);

		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(177,74);
		setVisible(false);
		move(200,200);
		exitLb.setText("Do you want to exit?");
		exitLb.setAlignment(java.awt.Label.CENTER);
		add(exitLb);
		exitLb.setBounds(24,12,140,21);
		yesButton.setLabel("Yes");
		add(yesButton);
		yesButton.setBackground(java.awt.Color.lightGray);
		yesButton.setForeground(java.awt.Color.black);
		yesButton.setBounds(36,48,52,20);
		NoButton.setLabel("No");
		add(NoButton);
		NoButton.setBackground(java.awt.Color.lightGray);
		NoButton.setForeground(java.awt.Color.black);
		NoButton.setBounds(96,48,52,20);
		setResizable(false);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		yesButton.addActionListener(lSymAction);
		NoButton.addActionListener(lSymAction);
		//}}
	}
	
	public RUSureDialog(Frame parent, boolean modal)
	{
		this(parent);
        setModal(modal);
	}
	
	public boolean isAccepted(){
		return accepted;
	}
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public RUSureDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label exitLb = new java.awt.Label();
	java.awt.Button yesButton = new java.awt.Button();
	java.awt.Button NoButton = new java.awt.Button();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == RUSureDialog.this)
				RUSureDialog_WindowClosing(event);
		}
	}
	
	void RUSureDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == yesButton)
				yesButton_ActionPerformed(event);
			else if (object == NoButton)
				NoButton_ActionPerformed(event);
		}
	}

	void yesButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		yesButton_ActionPerformed_Interaction1(event);
	}

	void yesButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
		    accepted=true;
			setVisible(false);
		} catch (Exception e) {
		}
	}

	void NoButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		NoButton_ActionPerformed_Interaction1(event);
	}

	void NoButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
            setVisible(false);
		} catch (Exception e) {
		}
	}
}
