/*
Dialog used to get the filename and level/game name for save operations.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

import symantec.itools.awt.util.dialog.ModalDialog;

public class SaveLevelDialog extends ModalDialog
{
    private boolean cancel=false;
	public SaveLevelDialog(Frame parent, String title)
	{
		super(parent, title);

		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(269,130);
		setVisible(false);
		fileNameLabel.setText("File Name:");
		add(fileNameLabel);
		fileNameLabel.setBounds(10,32,75,15);
		nameLabel.setText("Level Name:");
		add(nameLabel);
		nameLabel.setBounds(10,60,75,15);
		add(fileNameTextField);
		fileNameTextField.setBackground(java.awt.Color.white);
		fileNameTextField.setForeground(java.awt.Color.black);
		fileNameTextField.setBounds(85,28,150,22);
		add(levelNameTextField);
		levelNameTextField.setBackground(java.awt.Color.white);
		levelNameTextField.setForeground(java.awt.Color.black);
		levelNameTextField.setBounds(85,57,150,22);
		okButton.setLabel("OK");
		add(okButton);
		okButton.setBackground(java.awt.Color.lightGray);
		okButton.setForeground(java.awt.Color.black);
		okButton.setBounds(72,96,52,24);
		CancelButton.setLabel("Cancel");
		add(CancelButton);
		CancelButton.setBackground(java.awt.Color.lightGray);
		CancelButton.setForeground(java.awt.Color.black);
		CancelButton.setBounds(144,96,52,24);
		setTitle("Save Level");
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		CancelButton.addActionListener(lSymAction);
		//}}
	}
	
	public SaveLevelDialog(Frame parent)
	{
		this(parent, "Save Level");
	}

	// Add a constructor for Interactions (ignoring modal)
	public SaveLevelDialog(Frame parent, boolean modal)
	{
		this(parent);
	}

	// Add a constructor for Interactions (ignoring modal)
	public SaveLevelDialog(Frame parent, String title, boolean modal)
	{
		this(parent, title);
	}

	public boolean isCanceled(){
		return cancel;
	}
	public String getFileName(){
	       return fileNameTextField.getText();
	}
	public String getLevelName(){
	       return levelNameTextField.getText();
	}
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	Label nameLabel = new Label();
	Label fileNameLabel = new Label();
	TextField fileNameTextField = new TextField();
	TextField levelNameTextField = new TextField();
	Button okButton = new Button();
	Button CancelButton = new Button();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_ActionPerformed(event);
			else if (object == CancelButton)
				CancelButton_ActionPerformed(event);
		}
	}

	protected void okButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		okButton_ActionPerformed_Interaction1(event);
	}

	protected void okButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// SaveLevelDialog Hide the SaveLevelDialog
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	protected void CancelButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		CancelButton_ActionPerformed_Interaction1(event);
	}

	protected void CancelButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// SaveLevelDialog Hide the SaveLevelDialog
            cancel=true;
			this.setVisible(false);
		} catch (Exception e) {
		}
	}
}
