/*
Dialog used to set the settings for a new game.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import symantec.itools.awt.util.spinner.NumericSpinner;
import symantec.itools.multimedia.ImageViewer;

public class SettingsDialog extends Dialog
{
	private GreetingFrame owner;

	public SettingsDialog(Frame parent)
	{
		super(parent);
		owner=(GreetingFrame)parent;
		setLayout(null);
		setBackground(java.awt.Color.black);
		setForeground(java.awt.Color.green);
		setSize(385,420);
		setVisible(false);
		titleLabel.setText("Settings");
		titleLabel.setBounds(160,22,85,28);
		titleLabel.setForeground(Color.blue);
		titleLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		add(titleLabel);
		musicCheck.setLabel("Play Music and Sounds");
		add(musicCheck);
		musicCheck.setState(owner.isPlayingMusic());
		musicCheck.setBounds(60,72,168,28);
		bckLabel.setText("Background Color");
		add(bckLabel);
		bckLabel.setBounds(60,144,108,24);
		bckColorText.setEditable(false);
		bckColorText.setEnabled(false);
		add(bckColorText);
		bckColorText.setBackground(owner.getBckColor());
		bckColorText.setBounds(168,144,23,21);
		redSpinner.setBlockIncrement(1);
		add(redSpinner);
		redSpinner.setValue(owner.getBckColor().getRed());
		redSpinner.setBounds(264,120,51,16);
		blueSpinner.setBlockIncrement(1);
		add(blueSpinner);
		blueSpinner.setValue(owner.getBckColor().getBlue());
		blueSpinner.setBounds(264,144,51,16);
		greenSpinner.setBlockIncrement(1);
		add(greenSpinner);
		greenSpinner.setValue(owner.getBckColor().getGreen());
		greenSpinner.setBounds(264,168,51,16);
		redLb.setText("Red");
		add(redLb);
		redLb.setBounds(216,120,43,22);
		blueLb.setText("Blue");
		add(blueLb);
		blueLb.setBounds(216,144,43,22);
		greenLb.setText("Green");
		add(greenLb);
		greenLb.setBounds(216,168,43,22);
		try {
			bckImView.setImageURL(symantec.itools.net.RelativeURL.getURL("Images/background.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		catch(java.beans.PropertyVetoException e) { }
		add(bckImView);
		bckImView.setBounds(204,204,111,108);
		imFileText.setText("Images/background.gif");
		add(imFileText);
		imFileText.setBackground(java.awt.Color.white);
		imFileText.setForeground(java.awt.Color.black);
		imFileText.setBounds(108,324,207,19);
		fileLb.setText("File:");
		add(fileLb);
		fileLb.setBounds(60,324,36,20);
		bckImCheck.setLabel("Background Image");
		bckImCheck.setState(owner.getBckImage()!=null);
		add(bckImCheck);
		bckImCheck.setForeground(java.awt.Color.green);
		bckImCheck.setBounds(60,204,128,17);
		OKButton.setLabel("OK");
		add(OKButton);
		OKButton.setBackground(java.awt.Color.lightGray);
		OKButton.setForeground(java.awt.Color.black);
		OKButton.setBounds(111,384,55,19);
		cancelButton.setLabel("Cancel");
		add(cancelButton);
		cancelButton.setBackground(java.awt.Color.lightGray);
		cancelButton.setForeground(java.awt.Color.black);
		cancelButton.setBounds(219,384,55,19);
		setTitle("Settings");
		setResizable(false);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		OKButton.addActionListener(lSymAction);
		cancelButton.addActionListener(lSymAction);
		SymAdjustment lSymAdjustment = new SymAdjustment();
		redSpinner.addAdjustmentListener(lSymAdjustment);
		blueSpinner.addAdjustmentListener(lSymAdjustment);
		greenSpinner.addAdjustmentListener(lSymAdjustment);
		SymKey aSymKey = new SymKey();
		imFileText.addKeyListener(aSymKey);
		//}}
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;



    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	Checkbox musicCheck = new Checkbox();
	Label bckLabel = new Label();
	TextField bckColorText = new TextField();
	Scrollbar redSpinner = new Scrollbar(Scrollbar.HORIZONTAL,0,10,0,255);
	Scrollbar blueSpinner = new Scrollbar(Scrollbar.HORIZONTAL,0,10,0,255);
	Scrollbar greenSpinner = new Scrollbar(Scrollbar.HORIZONTAL,0,10,0,255);
	Label redLb = new Label();
	Label titleLabel = new Label();
	Label blueLb = new Label();
	Label greenLb = new Label();
	symantec.itools.multimedia.ImageViewer bckImView = new symantec.itools.multimedia.ImageViewer();
	Checkbox tiledRB = new Checkbox();
	CheckboxGroup Group1 = new CheckboxGroup();
	Checkbox centeredRB = new Checkbox();
	Checkbox stretchRB = new Checkbox();
	TextField imFileText = new TextField();
	Label fileLb = new Label();
	Checkbox bckImCheck = new Checkbox();
	Button OKButton = new Button();
	Button cancelButton = new Button();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SettingsDialog.this)
				SettingsDialog_WindowClosing(event);
		}
	}
	
	protected void SettingsDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == OKButton)
				OKButton_ActionPerformed(event);
			else if (object == cancelButton)
				cancelButton_ActionPerformed(event);
		}
	}

	protected void OKButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		OKButton_ActionPerformed_Interaction1(event);
	}

	protected void OKButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			owner.setBckImage(bckImCheck.getState()?getToolkit().getImage(imFileText.getText()):null);
			owner.setBckColor(bckColorText.getBackground());
			owner.setPlayMusic(musicCheck.getState());
			setVisible(false);
		} catch (Exception e) {
		}
	}

	protected void cancelButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		cancelButton_ActionPerformed_Interaction1(event);
	}

	protected void cancelButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			setVisible(false);
		} catch (Exception e) {
		}
	}

	class SymAdjustment implements java.awt.event.AdjustmentListener
	{
		public void adjustmentValueChanged(java.awt.event.AdjustmentEvent event)
		{
			Color locC=new Color(redSpinner.getValue(),greenSpinner.getValue(),blueSpinner.getValue());
			bckColorText.setBackground(locC);
		}
	}

	class SymKey extends java.awt.event.KeyAdapter
	{
		public void keyPressed(java.awt.event.KeyEvent event)
		{
			Object object = event.getSource();
			if (object == imFileText)
				imFileText_KeyPressed(event);
		}
	}

	protected void imFileText_KeyPressed(java.awt.event.KeyEvent event)
	{
			 
		imFileText_KeyPressed_Interaction1(event);
	}

	protected void imFileText_KeyPressed_Interaction1(java.awt.event.KeyEvent event)
	{
			if(event.getKeyCode()==java.awt.event.KeyEvent.VK_ENTER){
				try {
					bckImView.setImageURL(symantec.itools.net.RelativeURL.getURL(imFileText.getText()));
				}
				catch (java.net.MalformedURLException error) { }
				catch(java.beans.PropertyVetoException e) { }		
			}		
		
	}
}
