/*
The wall class used for the objects surrounding the game frame.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;
import java.awt.image.*;

public class Wall extends ObjectTemplate
{
    private int side;
    static final int RIGHT=1,LEFT=-1,TOP=0;
    private static final String imageFile="Images/Wall.gif";
    private Image wholeImage;
    static final int SIZE=10;
    
    Wall(int parX, int parY, int parSide, int parSize, Component parOwner,LevelTemplate parLevel){
        super(parX, parY, parOwner,parLevel);
        side=parSide;
        if (side==TOP){
            setWidth(parSize);
            setHeight(SIZE);
        }
        else{
            setHeight(parSize);
            setWidth(SIZE);
        }
        getImage(side);    
    }
    
    protected void getImage(int side){
        try{
            wholeImage=owner.getToolkit().getImage(imageFile);
        try {
            MediaTracker tracker = new MediaTracker(owner);
            tracker.addImage(wholeImage, 0);
            tracker.waitForID(0);
        }
        catch ( Exception e ) {}

        }
        catch(Exception e){
            System.out.println("Image file for wall object could not be found! [image/Ball.gif]");
        }
        ImageProducer producer;
        CropImageFilter locCrop;
        locCrop=new CropImageFilter(0,0,10,300);
        switch(side){
            case LEFT:
                locCrop=new CropImageFilter(0,10,10,300);
                break;
            case RIGHT:
                locCrop=new CropImageFilter(10,10,10,300);
                break;            
        }
        producer = new FilteredImageSource(wholeImage.getSource(), locCrop);
        imageOfObject = owner.createImage(producer);
        try {
            MediaTracker tracker = new MediaTracker(owner);
            tracker.addImage(imageOfObject, 0);
            tracker.waitForID(0);
        }
        catch ( Exception e ) {}
        
    }
    
}