
/*
*
*
*   Author: Christian Sarmoria   Base code taken from CPS616 course.
*
*   Date:   02-25-99
*
*   Course: CPS - 616 Project #1
*
*   File name: DBServlet.java
*
*
*   The flow of the program is the following:
*
*   1- Load initial HTML form
*   2- Make call to servlet DBServlet.class (query to Oracle)
*   3- Return html code with data on it
*
*
*    DBServlet.java appication for the servlet to connect to Oracle database.
*    Errors and informational messages can be viewed on the Java Console.
*/


// Importing from JDK


package ce00par;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.sql.*;

// The main servlet class.
public class DBServlet extends HttpServlet {

    /**
     * service method
     */
    public void service(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {

        String country;
	Connection con;
	PrintStream out;

	// fetch the parameters
	country = req.getParameter("Query");
//	password = req.getParameter("Country");
//	query = req.getParameter("Continent");

	res.setContentType("text/html");
	out = new PrintStream(res.getOutputStream());
	printPageHeader(out);

	// if no parameters, just print the form
	if (country == null) {
	    printPageFooter(out);
	    return;
	}

	String url	 = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";

	out.println("<body bgcolor=\"#CC6600\" topmargin=\"0\" leftmargin=\"0\">");

	try {
	    // find the jdbc driver
		Class.forName("oracle.jdbc.driver.OracleDriver");

	    // get the connection to the database
	    con = DriverManager.getConnection(url, "cy99cps", "cy99cps");
	    out.println("<hr>");
//	    out.println("<h3>JDBC Driver and Database Messages</h3>");
	    checkForWarning(con.getWarnings(), out);
	    DatabaseMetaData dma = con.getMetaData();
//	    out.println("Connected to " + dma.getURL() + "<br>");
//	    out.println("Driver       " + dma.getDriverName() + "<br>");
//	    out.println("Version      " + dma.getDriverVersion() + "<br>");

	    // create and execute the query
	    Statement stmt = con.createStatement();
	    ResultSet rs = stmt.executeQuery("Select * from Countries, continents where name = '" + country + "' and countries.continent = continents.contname");

	    // print out the result
	    dispResultSet(rs, out);
	    rs.close();
	    stmt.close();
	    con.close();
	    out.println("<hr>");
	}
	catch (SQLException ex) {
	    out.println("<hr>*** SQLException caught ***<p>");
	    while (ex != null) {
	      out.println("SQLState: " + ex.getSQLState() + "<br>");
	      out.println("Message:  " + ex.getMessage() + "<br>");
	      out.println("Vendor:   " + ex.getErrorCode() + "<br>");
	      ex = ex.getNextException();
	    }
	}
	catch (java.lang.Exception ex) {
	    ex.printStackTrace();
	}

	printPageFooter(out);
    }

    /**
     * returns the servlet info
     */
    public String getServletInfo() {
	return "This is a simple servlet that shows how to use JDBC with servlets";
    }


    /*
     * check if the database server has anything to say
     */
    private void checkForWarning(SQLWarning warn, PrintStream out)
          throws SQLException
    {
       boolean rc = false;

       if (warn != null) {
          out.println("<hr>*** Warning ***<p>");
          rc = true;
          while (warn != null) {
             out.println("SQLState: " + warn.getSQLState() + "<br>");
             out.println("Message:  " + warn.getMessage() + "<br>");
             out.println("Vendor:   " + warn.getErrorCode() + "<br>");
             warn = warn.getNextWarning();
          }
       }
    }


    /*
     * display the result in html table format
     */
    private void dispResultSet(ResultSet rs, PrintStream out)
       throws SQLException
    {
        rs.next();

	out.println("<body bgcolor=\"#CC6600\" topmargin=\"0\" leftmargin=\"0\">");

	out.println("<form");

	out.println("action=\"http://class-server.npac.syr.edu:61699/cps616spring99-servlets/cy99cps/DBServlet\"");
	out.println("method=\"GET\">");
	out.println("    <p><font color=\"#004080\"><em>Christian Sarmoria - CPS616 -");
	out.println("    Assignment #2</em></font></p>");
	out.println("    <p align=\"center\"><font color=\"#800080\" size=\"5\"><em><b>Java");
	out.println("    Servlet - Oracle Database </b></em></font></p>");
	out.println("    <blockquote>");
	out.println("        <blockquote>");
	out.println("            <hr size=\"3\" color=\"#00FF00\">");
	out.println("            <pre><font color=\"#00FF00\" size=\"3\"><strong><u>Select the Country name:</u></strong></font><font");

	out.println("color=\"#00FF00\" size=\"1\"> </font><select name=\"Query\" size=\"1\"><option>France</option><option>Germany</option><option>Argentina</option><option>Usa</option><option>Brazil</option><option>Canada</option><option>Japan</option><option>Italy</option><option>India</option><option>Colombia</option><option>Mexico</option><option>Peru</option></select> <input");

	out.println("type=\"submit\" value=\"Search\"> </pre>");
	out.println("            <pre><font color=\"#FFFF00\"><strong> </strong></font><font");

	out.println("color=\"#FFFF99\"><em><strong>      </strong></em></font><font");

	out.println("color=\"#FFFF00\"><strong>Country</strong></font><font");

	out.println("color=\"#FFFF99\"><em><strong> :</strong></em></font> <font");

//	out.println("color=\"#00FFFF\" size=\"4\"><em><b>Aca va el pais</b></em></font><font");
	out.println("color=\"#00FFFF\" size=\"4\"><em><b>" + rs.getString(1) + "</b></em></font><font");

	out.println("color=\"#800080\" size=\"5\"><em><b>        <img src=\"http://carver.npac.syr.edu:3768/cps616spring99-docs/cy99cps/assign2/" + rs.getString(1) + ".jpg\"");
	out.println("width=\"106\" height=\"50\"></b></em></font>");
	out.println("<font color=\"#FFFF99\"><em><strong>       Capital :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(2) + "</strong></font>");
	out.println("<font color=\"#FFFF99\"><em><strong>    Population :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(3) + "</strong></font>");
	out.println("<font color=\"#FFFF99\"><em><strong>     Continent :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(4) + "</strong></font>");
	out.println("   <font color=\"#FFFF99\"><em><strong>  Risk Rate :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(5) + "</strong></font>");
	out.println("  <font color=\"#FFFFCC\"><em><strong>  Hemisphere :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(7) + "</strong></font>");
	out.println("  <font color=\"#FFFFCC\"><em><strong>  Discovered :</strong></em></font> <font");

	out.println("color=\"#80FFFF\"><strong>" + rs.getString(8) + "</strong></font></pre>");
	out.println("        </blockquote>");
	out.println("        <hr size=\"3\" color=\"#008000\">");
	out.println("    </blockquote>");
	out.println("</form>");

	out.println("<p align=\"center\"><a");

	out.println("href=\"http://carver.npac.syr.edu:3768/cps616spring99-docs/cy99cps/assign2/assign2.html\"><em><strong>Go");
	out.println("back to the assignment #2 page</strong></em></a><em><strong> </strong></em></p>");
	out.println("</body>");
	out.println("</html>");

       int i;

       // metadata can supply information about the schema
       ResultSetMetaData rsmd = rs.getMetaData();
       int numCols = rsmd.getColumnCount();
       out.println("<hr>");
       out.println("<h3>Database Columns and Data</h3>");
       out.println("<table border=3>");
       out.println("<tr>");
       for (i=1; i<=numCols; i++) {
          out.println("<th>" + rsmd.getColumnLabel(i) + "</th>");
       }
       out.println("</tr>");

       // for entire data
//       while (rs.next()) {
	  out.println("<tr>");

	  // for one row
          for (i=1; i<=numCols; i++) {
	     dispElement(rs, rsmd.getColumnType(i), out, i);
          }
	  out.println("</tr>");
//       }
       out.println("</table>");
    }


    // print one element
    private void dispElement(ResultSet rs, int dataType,
			     PrintStream out, int col)
          throws SQLException
    {

        // ask for data depending on the datatype
	switch(dataType) {
	case Types.DATE:
	  java.sql.Date date = rs.getDate(col);
	  out.println("<th>" + date.toString() + "</th>");
	  break;
	case Types.TIME:
	  java.sql.Time time = rs.getTime(col);
	  out.println("<th>" + time.toString() + "</th>");
	  break;
	case Types.TIMESTAMP:
	  java.sql.Timestamp timestamp = rs.getTimestamp(col);
	  out.println("<th>" + timestamp.toString() + "</th>");
	  break;
	case Types.CHAR:
	case Types.VARCHAR:
	case Types.LONGVARCHAR:
	  String str = rs.getString(col);
	  out.println("<th>" + str + "</th>");
	  break;
	case Types.NUMERIC:
	case Types.DECIMAL:
	  java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
	  out.println("<th>" + numeric.toString() + "</th>");
	  break;
	case Types.BIT:
	  boolean bit = rs.getBoolean(col);
	  out.println("<th>" + new Boolean(bit) + "</th>");
	  break;
	case Types.TINYINT:
	  byte tinyint = rs.getByte(col);
	  out.println("<th>" + new Integer(tinyint) + "</th>");
	  break;
	case Types.SMALLINT:
	  short smallint = rs.getShort(col);
	  out.println("<th>" + new Integer(smallint) + "</th>");
	  break;
	case Types.INTEGER:
	  int integer = rs.getInt(col);
	  out.println("<th>" + new Integer(integer) + "</th>");
	  break;
	case Types.BIGINT:
	  long bigint = rs.getLong(col);
	  out.println("<th>" + new Long(bigint) + "</th>");
	  break;
	case Types.REAL:
	  float real = rs.getFloat(col);
	  out.println("<th>" + new Float(real) + "</th>");
	  break;
	case Types.FLOAT:
	case Types.DOUBLE:
	  double longreal = rs.getDouble(col);
	  out.println("<th>" + new Double(longreal) + "</th>");
	  break;
	case Types.BINARY:
	case Types.VARBINARY:
	case Types.LONGVARBINARY:
	  byte[] binary = rs.getBytes(col);
	  out.println("<th>" + new String(binary, 0) + "</th>");
	  break;
	}
    }


    // Simple html header
    private void printPageHeader(PrintStream out) {


	out.println("<html>");

	out.println("<head>");
	out.println("<meta http-equiv=\"Content-Type\"");
	out.println("content=\"text/html; charset=iso-8859-1\">");
	out.println("<meta name=\"GENERATOR\" content=\"Microsoft FrontPage Express 2.0\">");
	out.println("<title>http://chris/images/DBServlet.html</title>");
	out.println("<tltle>");
	out.println("</head>");

    }


    private void printPageFooter(PrintStream out) {
        out.println("</body>");
	out.println("</html>");
	out.flush();
    }
}

// end
// The code was modified from the example in class
// HTML form is my own implementation.
// Christian Sarmoria
// cgsarmor@mailbox.syr.edu
