
/*
*
*
*   Author: Christian Sarmoria   Base code taken from CPS616 course.
*
*   Date:   05-05-99
*
*   Course: CPS - 616 Final Project
*
*   File name: ItemsDBServlet.java
*
*
*   The flow of the program is the following:
*
*   1- Load initial HTML form
*   2- Make call to servlet ItemsDBServlet.class (query to Oracle)
*   3- Return html code with data on it
*
*
*    ItemsDBServlet.java appication for the servlet to connect to Oracle database.
*    Errors and informational messages can be viewed on the Java Console.
*/


// Importing from JDK


package cy99cps;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.sql.*;

// The main servlet class.
public class ItemsDBServlet extends HttpServlet {

    /**
     * service method
     */
    public void service(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {

        String group;
	Connection con;
	PrintStream out;

	// fetch the parameters
	group = req.getParameter("Query");
//	password = req.getParameter("Country");
//	query = req.getParameter("Continent");

	res.setContentType("text/html");
	out = new PrintStream(res.getOutputStream());
	printPageHeader(out);

	// if no parameters, just print the form
	if (group == null) {
	    printPageFooter(out);
	    return;
	}

	String url	 = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";

//	out.println("<body bgcolor=\"#CC6600\" topmargin=\"0\" leftmargin=\"0\">");

	try {
	    // find the jdbc driver
		Class.forName("oracle.jdbc.driver.OracleDriver");

	    // get the connection to the database
	    con = DriverManager.getConnection(url, "cy99cps", "cy99cps");
//	    out.println("<hr>");
//	    out.println("<h3>JDBC Driver and Database Messages</h3>");
	    checkForWarning(con.getWarnings(), out);
	    DatabaseMetaData dma = con.getMetaData();
//	    out.println("Connected to " + dma.getURL() + "<br>");
//	    out.println("Driver       " + dma.getDriverName() + "<br>");
//	    out.println("Version      " + dma.getDriverVersion() + "<br>");

	    // create and execute the query
	    Statement stmt = con.createStatement();
	    ResultSet rs = stmt.executeQuery("Select * from " + group);

	    // print out the result
	    dispResultSet(rs, out);
	    rs.close();
	    stmt.close();
	    con.close();
//	    out.println("<hr>");
	}
	catch (SQLException ex) {
	    out.println("<hr>*** SQLException caught ***<p>");
	    while (ex != null) {
	      out.println("SQLState: " + ex.getSQLState() + "<br>");
	      out.println("Message:  " + ex.getMessage() + "<br>");
	      out.println("Vendor:   " + ex.getErrorCode() + "<br>");
	      ex = ex.getNextException();
	    }
	}
	catch (java.lang.Exception ex) {
	    ex.printStackTrace();
	}

	printPageFooter(out);
    }

    /**
     * returns the servlet info
     */
    public String getServletInfo() {
	return "This is a simple servlet that shows how to use JDBC with servlets";
    }


    /*
     * check if the database server has anything to say
     */
    private void checkForWarning(SQLWarning warn, PrintStream out)
          throws SQLException
    {
       boolean rc = false;

       if (warn != null) {
          out.println("<hr>*** Warning ***<p>");
          rc = true;
          while (warn != null) {
             out.println("SQLState: " + warn.getSQLState() + "<br>");
             out.println("Message:  " + warn.getMessage() + "<br>");
             out.println("Vendor:   " + warn.getErrorCode() + "<br>");
             warn = warn.getNextWarning();
          }
       }
    }


    /*
     * display the result in html table format
     */
    private void dispResultSet(ResultSet rs, PrintStream out)
       throws SQLException
    {
            boolean goon = true;
        while (rs.next())
        {

//            try {
                  rs.next();
out.println("	<TR>");
out.println("		<TD WIDTH=\"50%\">");


out.println("			<BLOCKQUOTE>");

out.println("			<BLOCKQUOTE>");
out.println("			<PRE><FONT COLOR=\"#FFFF00\"><STRONG></STRONG></FONT></PRE>");

out.println("			<PRE><FONT COLOR=\"#FFFF00\"><STRONG> </STRONG></FONT><FONT COLOR=\"#FFFF99\"><STRONG><EM>    </EM></STRONG></FONT><FONT");
out.println("			COLOR=\"#FFFF00\"><STRONG>Code   </STRONG></FONT><FONT COLOR=\"#FFFF99\"><STRONG><EM> :</EM></STRONG></FONT> <FONT");
out.println("			COLOR=\"#66FFFF\"><I><B>" + rs.getString(3) + "</B></I></FONT></PRE>");

out.println("			<PRE><FONT COLOR=\"#FFFF99\"><STRONG><EM>     Name    :</EM></STRONG></FONT> <FONT COLOR=\"#66FFFF\"><I><B>" + rs.getString(2) + "</B></I></FONT>");
out.println("<FONT COLOR=\"#FFFF99\"><STRONG><EM>     Made in :</EM></STRONG></FONT> <FONT COLOR=\"#66FFFF\"><I><B>" + rs.getString(3) + "</B></I></FONT>");
out.println("<FONT COLOR=\"#FFFF99\"><STRONG><EM>     Image   :</EM></STRONG></FONT> <FONT COLOR=\"#66FFFF\"><I><B>" + rs.getString(4) + "</B></I></FONT>");
out.println("   <FONT COLOR=\"#FFFF99\"><STRONG><EM>  Price   :</EM></STRONG></FONT> <FONT COLOR=\"#66FFFF\"><I><B>" + rs.getString(5) + "</B></I></FONT>");
out.println("  <FONT COLOR=\"#FFFFCC\"><STRONG><EM>   Scale   :</EM></STRONG></FONT> <FONT COLOR=\"#66FFFF\"><I><B>" + rs.getString(6) + "</B></I></FONT></PRE>");
out.println("			</BLOCKQUOTE>			</BLOCKQUOTE>");
out.println("		</TD>");
out.println("		<TD WIDTH=\"50%\">");
out.println("			<P ALIGN=\"CENTER\"><IMG SRC=\"http://carver.npac.syr.edu:3768/cps616spring99-docs/cy99cps/finalproject/" + rs.getString(4) + "\" WIDTH=\"175\" HEIGHT=\"139\" ALIGN=\"BOTTOM\" BORDER=\"0\">");
out.println("		</TD>");
out.println("	</TR>");


 //              }


 //           catch (Exception e) {
 //                     goon = false;
 //                     System.err.println("No more records");
//      e.printStackTrace();

            }


 //       }
 // }

/*

       int i;

       // metadata can supply information about the schema
       ResultSetMetaData rsmd = rs.getMetaData();
       int numCols = rsmd.getColumnCount();
       out.println("<hr>");
       out.println("<h3>Database Columns and Data</h3>");
       out.println("<table border=3>");
       out.println("<tr>");
       for (i=1; i<=numCols; i++) {
          out.println("<th>" + rsmd.getColumnLabel(i) + "</th>");
       }
       out.println("</tr>");

       // for entire data
//       while (rs.next()) {
	  out.println("<tr>");

	  // for one row
          for (i=1; i<=numCols; i++) {
	     dispElement(rs, rsmd.getColumnType(i), out, i);
          }
	  out.println("</tr>");
//       }
       out.println("</table>");
*/

    }


    // print one element
    private void dispElement(ResultSet rs, int dataType,
			     PrintStream out, int col)
          throws SQLException
    {

        // ask for data depending on the datatype
	switch(dataType) {
	case Types.DATE:
	  java.sql.Date date = rs.getDate(col);
	  out.println("<th>" + date.toString() + "</th>");
	  break;
	case Types.TIME:
	  java.sql.Time time = rs.getTime(col);
	  out.println("<th>" + time.toString() + "</th>");
	  break;
	case Types.TIMESTAMP:
	  java.sql.Timestamp timestamp = rs.getTimestamp(col);
	  out.println("<th>" + timestamp.toString() + "</th>");
	  break;
	case Types.CHAR:
	case Types.VARCHAR:
	case Types.LONGVARCHAR:
	  String str = rs.getString(col);
	  out.println("<th>" + str + "</th>");
	  break;
	case Types.NUMERIC:
	case Types.DECIMAL:
	  java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
	  out.println("<th>" + numeric.toString() + "</th>");
	  break;
	case Types.BIT:
	  boolean bit = rs.getBoolean(col);
	  out.println("<th>" + new Boolean(bit) + "</th>");
	  break;
	case Types.TINYINT:
	  byte tinyint = rs.getByte(col);
	  out.println("<th>" + new Integer(tinyint) + "</th>");
	  break;
	case Types.SMALLINT:
	  short smallint = rs.getShort(col);
	  out.println("<th>" + new Integer(smallint) + "</th>");
	  break;
	case Types.INTEGER:
	  int integer = rs.getInt(col);
	  out.println("<th>" + new Integer(integer) + "</th>");
	  break;
	case Types.BIGINT:
	  long bigint = rs.getLong(col);
	  out.println("<th>" + new Long(bigint) + "</th>");
	  break;
	case Types.REAL:
	  float real = rs.getFloat(col);
	  out.println("<th>" + new Float(real) + "</th>");
	  break;
	case Types.FLOAT:
	case Types.DOUBLE:
	  double longreal = rs.getDouble(col);
	  out.println("<th>" + new Double(longreal) + "</th>");
	  break;
	case Types.BINARY:
	case Types.VARBINARY:
	case Types.LONGVARBINARY:
	  byte[] binary = rs.getBytes(col);
	  out.println("<th>" + new String(binary, 0) + "</th>");
	  break;
	}
    }


    // Simple html header
    private void printPageHeader(PrintStream out) {

out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">");
out.println("<HTML>");

out.println("<HEAD>");
out.println("	<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=iso-8859-1\">");
out.println("<tltle>");

out.println("	<META NAME=\"GENERATOR\" Content=\"Visual Page 1.1a for Windows\">");
out.println("	<TITLE>http://chris/images/DBServlet.html</TITLE>");
out.println("</HEAD>");

out.println("<BODY BGCOLOR=\"#9900CC\" topmargin=\"0\" leftmargin=\"0\">");

out.println("<FORM ACTION=\"http://class-server.npac.syr.edu:61699/cps616spring99-servlets/cy99cps/ItemsDBServlet\" METHOD=\"GET\">");
out.println("<CENTER>");
out.println("<P>");
out.println("<TABLE BORDER=\"0\" HEIGHT=\"188\">");
out.println("	<TR>");
out.println("		<TD WIDTH=\"335\" HEIGHT=\"180\">");
out.println("			<P ALIGN=\"CENTER\"><IMG SRC=\"http://carver.npac.syr.edu:3768/cps616spring99-docs/cy99cps/finalproject/ground/M-163Vulcan.gif\" WIDTH=\"205\" HEIGHT=\"154\" ALIGN=\"BOTTOM\" BORDER=\"0\">");
out.println("		</TD>");
out.println("		<TD HEIGHT=\"180\">");
out.println("			<P ALIGN=\"RIGHT\"><FONT COLOR=\"#000000\">Christian Samoria - CPS-616 Spring '99 - Final Project</FONT></P>");
out.println("			<P ALIGN=\"CENTER\"><FONT SIZE=\"7\" COLOR=\"#FF0000\"><I><B>S</B></I></FONT><FONT SIZE=\"7\" COLOR=\"#000000\"><I><B>caled</B></I></FONT><FONT");
out.println("			SIZE=\"7\"><I><B> </B></I></FONT><FONT SIZE=\"7\" COLOR=\"#00CCFF\"><I><B>W</B></I></FONT><FONT SIZE=\"7\" COLOR=\"#000000\"><I><B>ar</B></I></FONT><FONT");
out.println("			SIZE=\"7\"><I><B> </B></I></FONT><FONT SIZE=\"7\" COLOR=\"#00FF00\"><I><B>T</B></I></FONT><FONT SIZE=\"7\" COLOR=\"#000000\"><I><B>oys</B></I></FONT></P>");

out.println("			<P ALIGN=\"CENTER\"><FONT SIZE=\"5\" COLOR=\"#FFFFFF\"><I><B>Items Show</B></I></FONT>");
out.println("		</TD>");
out.println("	</TR>");
out.println("</TABLE>");
out.println("</P>");

out.println("<P></P>");
out.println("</CENTER>");


out.println("<BLOCKQUOTE>");

out.println("	<BLOCKQUOTE>");
out.println("		<P>");
out.println("<HR ALIGN=\"CENTER\" SIZE=\"3\" color=\"#00FF00\">");
out.println("</P>");
out.println("		<PRE><FONT SIZE=\"3\" COLOR=\"#00FF00\"><STRONG><U>Select a Category:</U></STRONG></FONT></PRE>");
out.println("		<CENTER>");
out.println("		<PRE>");
out.println("<SELECT NAME=\"Query\">");
out.println("		<OPTION>Jets</OPTION>");
out.println("		<OPTION>Ground</OPTION>");
out.println("		<OPTION>Copters</OPTION>");
out.println("</SELECT>  <INPUT TYPE=\"SUBMIT\" NAME=\"Search\" VALUE=\"Show items\"> </PRE>");
out.println("</CENTER>");
out.println("		<PRE></PRE>");

out.println("	</BLOCKQUOTE>");
out.println("	<P>");

out.println("<HR ALIGN=\"CENTER\" SIZE=\"3\" color=\"#008000\">");
out.println("</P>");

// begin of table
out.println("	<CENTER>");
out.println("	<P>");
out.println("	<TABLE BORDER=\"2\" WIDTH=\"79%\" HEIGHT=\"301\" BGCOLOR=\"#330066\">");


    }


    private void printPageFooter(PrintStream out) {
out.println("	</TABLE>");
out.println("</P>");
out.println("</CENTER>");
out.println("	<P>");

out.println("</BLOCKQUOTE>");

out.println("<HR ALIGN=\"CENTER\" SIZE=\"3\" color=\"#008000\">");

out.println("<P ALIGN=\"CENTER\"><A HREF=\"http://carver.npac.syr.edu:3768/cps616spring99-docs/cy99cps/finalproject/finalmain.html\"><FONT SIZE=\"3\" FACE=\"Times New Roman\" COLOR=\"Black\">Go back to the main");
out.println("page</FONT></A>");
out.println("</FORM>");

out.println("</BODY>");

out.println("</HTML>");
	out.flush();
    }
}

// end
// The code was modified from the example in class
// HTML form is my own implementation.
// Christian Sarmoria
// cgsarmor@mailbox.syr.edu
