

// Importing from JDK


package cz99cps;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.sql.*;

// The main servlet class.
public class ScheduleDBServlet extends HttpServlet {

    /**
     * service method
     */
    public void service(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
		String CourseDescription;
		String Semester;
		String Year;
		Connection con;
		PrintStream out;

		// fetch the parameters
		CourseDescription = req.getParameter("CourseDescription");
		Semester = req.getParameter("Semester");
		Year = req.getParameter("Year");

		res.setContentType("text/html");
		out = new PrintStream(res.getOutputStream());

 CourseDescription = "606 and CPS-616 ";
		printPageHeader(out, CourseDescription, Semester, Year);

		// if no parameters, just print the form
		if (CourseDescription == null) {
			printPageFooter(out);
			return;
		}

	String url	 = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";

	try {
	    // find the jdbc driver
		Class.forName("oracle.jdbc.driver.OracleDriver");

	    // get the connection to the database
	    con = DriverManager.getConnection(url, "cy99cps", "cy99cps");
	    checkForWarning(con.getWarnings(), out);
	    DatabaseMetaData dma = con.getMetaData();
//	    out.println("Connected to " + dma.getURL() + "<br>");
//	    out.println("Driver       " + dma.getDriverName() + "<br>");
//	    out.println("Version      " + dma.getDriverVersion() + "<br>");

	    // create and execute the query
	    Statement stmt = con.createStatement();

	    ResultSet rs = stmt.executeQuery("Select * from cpsprojectsdemo where (Semester = '" + Semester + "') AND (Year = " + Year + ") ORDER BY Slotnumber");
//	    ResultSet rs = stmt.executeQuery("Select * from cpsprojectsdemo where (cpscourse = " + CourseDescription + ") AND (Semester = '" + Semester + "') AND (Year = " + Year + ") ORDER BY DemoDate, DemoStarts");

	    // print out the result
	    dispResultSet(rs, out);
	    rs.close();
	    stmt.close();
	    con.close();
	}
	catch (SQLException ex) {
	    out.println("<hr>*** SQLException caught ***<p>");
	    while (ex != null) {
	      out.println("SQLState: " + ex.getSQLState() + "<br>");
	      out.println("Message:  " + ex.getMessage() + "<br>");
	      out.println("Vendor:   " + ex.getErrorCode() + "<br>");
	      ex = ex.getNextException();
	    }
	}
	catch (java.lang.Exception ex) {
	    ex.printStackTrace();
	}

	printPageFooter(out);
    }

    /**
     * returns the servlet info
     */
    public String getServletInfo() {
	return "This is a simple servlet that shows how to use JDBC with servlets";
    }


    /*
     * check if the database server has anything to say
     */
    private void checkForWarning(SQLWarning warn, PrintStream out)
          throws SQLException
    {
       boolean rc = false;

       if (warn != null) {
          out.println("<hr>*** Warning ***<p>");
          rc = true;
          while (warn != null) {
             out.println("SQLState: " + warn.getSQLState() + "<br>");
             out.println("Message:  " + warn.getMessage() + "<br>");
             out.println("Vendor:   " + warn.getErrorCode() + "<br>");
             warn = warn.getNextWarning();
          }
       }
    }


    /*
     * display the result in html table format
     */
    private void dispResultSet(ResultSet rs, PrintStream out)
       throws SQLException
    {
            boolean goon = true;
       String Name1, Name2, Name3, Project;
        while (rs.next())
        {
//            try {
//                  rs.next();

			Name1 = rs.getString(8);
			Name2 = rs.getString(10);
			Name3 = rs.getString(12);
			Project = rs.getString(14);

			if (rs.getString(8) == null){
				Name1 = "";
			}
				
			if (rs.getString(10) == null){
				Name2 = "";
			}
			else{
				Name2 = " / " + Name2;
			}
			if (rs.getString(12) == null){
				Name3 = "";
			}
  
			if (rs.getString(14) == null){
				Project = "";
			}
			else{
				Name3 = " / " + Name3;
			}

			out.println("  <tr>");

			out.println("    <td width=\"35%\" align=\"center\">" + Name1 + Name2 + Name3 + "</td>");
			out.println("    <td width=\"12%\"  align=\"center\">" + rs.getString(5) + "</td>");
			out.println("    <td width=\"7%\"  align=\"center\">" + rs.getString(6) + "</td>");
			out.println("    <td width=\"7%\"  align=\"center\">" + rs.getString(7) + "</td>");
			out.println("    <td width=\"39%\"  align=\"center\">" + Project + "</td>");
			out.println("  </tr>");

 //           catch (Exception e) {
 //                     goon = false;
 //                     System.err.println("No more records");
 //                     e.printStackTrace();

		}

/*

       int i;

       // metadata can supply information about the schema
       ResultSetMetaData rsmd = rs.getMetaData();
       int numCols = rsmd.getColumnCount();
       out.println("<hr>");
       out.println("<h3>Database Columns and Data</h3>");
       out.println("<table border=3>");
       out.println("<tr>");
       for (i=1; i<=numCols; i++) {
          out.println("<th>" + rsmd.getColumnLabel(i) + "</th>");
       }
       out.println("</tr>");

       // for entire data
//       while (rs.next()) {
	  out.println("<tr>");

	  // for one row
          for (i=1; i<=numCols; i++) {
	     dispElement(rs, rsmd.getColumnType(i), out, i);
          }
	  out.println("</tr>");
//       }
       out.println("</table>");
*/

    }


    // print one element
    private void dispElement(ResultSet rs, int dataType,
			     PrintStream out, int col)
          throws SQLException
    {

        // ask for data depending on the datatype
	switch(dataType) {
	case Types.DATE:
	  java.sql.Date date = rs.getDate(col);
	  out.println("<th>" + date.toString() + "</th>");
	  break;
	case Types.TIME:
	  java.sql.Time time = rs.getTime(col);
	  out.println("<th>" + time.toString() + "</th>");
	  break;
	case Types.TIMESTAMP:
	  java.sql.Timestamp timestamp = rs.getTimestamp(col);
	  out.println("<th>" + timestamp.toString() + "</th>");
	  break;
	case Types.CHAR:
	case Types.VARCHAR:
	case Types.LONGVARCHAR:
	  String str = rs.getString(col);
	  out.println("<th>" + str + "</th>");
	  break;
	case Types.NUMERIC:
	case Types.DECIMAL:
	  java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
	  out.println("<th>" + numeric.toString() + "</th>");
	  break;
	case Types.BIT:
	  boolean bit = rs.getBoolean(col);
	  out.println("<th>" + new Boolean(bit) + "</th>");
	  break;
	case Types.TINYINT:
	  byte tinyint = rs.getByte(col);
	  out.println("<th>" + new Integer(tinyint) + "</th>");
	  break;
	case Types.SMALLINT:
	  short smallint = rs.getShort(col);
	  out.println("<th>" + new Integer(smallint) + "</th>");
	  break;
	case Types.INTEGER:
	  int integer = rs.getInt(col);
	  out.println("<th>" + new Integer(integer) + "</th>");
	  break;
	case Types.BIGINT:
	  long bigint = rs.getLong(col);
	  out.println("<th>" + new Long(bigint) + "</th>");
	  break;
	case Types.REAL:
	  float real = rs.getFloat(col);
	  out.println("<th>" + new Float(real) + "</th>");
	  break;
	case Types.FLOAT:
	case Types.DOUBLE:
	  double longreal = rs.getDouble(col);
	  out.println("<th>" + new Double(longreal) + "</th>");
	  break;
	case Types.BINARY:
	case Types.VARBINARY:
	case Types.LONGVARBINARY:
	  byte[] binary = rs.getBytes(col);
	  out.println("<th>" + new String(binary, 0) + "</th>");
	  break;
	}
    }


    // Simple html header
    private void printPageHeader(PrintStream out, String CourseDescription, String Semester, String Year ) {
out.println("<html>");

out.println("<head>");
out.println("<meta http-equiv=\"Content-Type\" content=\"text/html  charset=windows-1252\">");
out.println("<meta http-equiv=\"Content-Language\" content=\"en-us\">");
out.println("<title>Schedule</title>");



//out.println("<meta name=\"GENERATOR\" content=\"Microsoft FrontPage 4.0\">");
// out.println("<meta name=\"ProgId\" content=\"FrontPage.Editor.Document\">");
//out.println("<meta name=\"Microsoft Theme\" content=\"copy-of-network-blitz 1000\">");
//out.println("<meta name=\"Microsoft Border\" content=\"tl, default\">");
out.println("<p align=\"center\"><font size=\"6\"><strong><img src=\"//carver.npac.syr.edu:3768/cps714summer99-docs/cz99cps/IS/Schedule.gif\" width=\"600\" height=\"60\" border=\"0\"></strong></font><br>");
out.println("</head>");

out.println("<body><p align=\"center\"><b><font color=\"#000000\">This page displays the slots of");
out.println("the selected course to read the schedule.</font></b></p>");


out.println("<hr>");
out.println("<p align=\"left\"><b><font color=\"#000000\">This is the so far Schedule for CPS-" + CourseDescription + " " + Semester + "/" + Year);
out.println("</font></b></p>");
out.println("<hr>");
out.println("<table border=\"1\" width=\"100%\">");
  out.println("<tr>");
    out.println("<td width=\"35%\" align=\"center\"><b><i><font color=\"#800000\">Student</font></i></b></td>");
    out.println("<td width=\"12%\" align=\"center\"><b><i><font color=\"#800000\">Date</font></i></b></td>");
    out.println("<td width=\"7%\" align=\"center\"><b><i><font color=\"#800000\">Starts</font></i></b></td>");
    out.println("<td width=\"7%\" align=\"center\"><b><i><font color=\"#800000\">Finishes</font></i></b></td>");
    out.println("<td width=\"39%\" align=\"center\"><b><i><font color=\"#800000\">Project</font></i></b></td>");
  out.println("</tr>");
  
  }


    private void printPageFooter(PrintStream out) {



out.println("</table>");
out.println("<p>&nbsp </p>");
out.println("<hr>");
out.println("<p><i>Problems when signing-up?&nbsp  e-mail:</i>  <a href=\"mailto:cgsarmor@mailbox.syr.edu\">cgsarmor@mailbox.syr.edu</a></p>");

out.println("<hr>");
out.println("</body>");

out.println("</html>");


	out.flush();
    }
}

// end
// Christian Sarmoria
// cgsarmor@mailbox.syr.edu
