///////////////////////////////////////////////////////////////////////////
// myDatabase.java Uses SQL plus commands for manipulating tables by JDBC
// Version:     1.0
// Language:    Visual J++, ver 6,0
// Platform:    Windows NT 4.00
// Project:     CPS616 Homework #2, Spring 2000
// Author:      Mehmet Akif Nacar 
// e-mail:      manacar@mailbox.syr.edu   
///////////////////////////////////////////////////////////////////////////

import java.sql.*;
import java.util.Properties;

// It has some methods for manipulating SQL tables by JDBC
class myDatabase {

  private Connection conn;

  // Opens a connection to the Oracle server by JDBC   
  public void open() throws Exception
  {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "ce00nma", "ce00nma");
      System.out.println("Connection Open");
    } 
    catch (Exception e) 
    { 
      throw new Exception("Error connection:" + e.getMessage());
    }
  }

  // To find an item form Item table by SQL
  public String balance( String acc_id, String passw, String acc_type) throws Exception
  {
    try {
		System.out.println("Item passed = " + acc_id);
        //binding input parameter to SQL call      
        PreparedStatement pstmt = conn.prepareStatement("select * from acc_type where acc_id = ?");
        pstmt.setString(1, acc_id);

        // Execute the SQL, ResultSet is row(s) of data returned by database query
        ResultSet rs = pstmt.executeQuery();
        
        rs.next();
		acc_id = rs.getString("acc_id");
        String balance = rs.getString("balance");   
         
        // closing statement
        pstmt.close();
		// return price of item to the Client side
        return balance;
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }

 /* 
  // To record a transaction to the transaction and customer tables by SQL
  public String transfer( String acc_id, String passw, String fromNo, String toNo, String amount) throws Exception
  {
    try {
		System.out.println("Transaction = " + computer);
		
		// get given item price from item table
		int price = find(computer);
	
		// record the customer info to the customer table
		insertToCustomer( computer, name, address, payment, price);
        //binding input parameter to TRANSACTION table      
   
		PreparedStatement pstmt = conn.prepareStatement("insert into transaction (item, custom, price) values(?, ?, ?)" );
       
		pstmt.setString(1, computer );
		pstmt.setString(2, name );
		pstmt.setInt(3, price );
		
        // Execute the SQL, ResultSet is row(s) of data returned by database query
		int ins=pstmt.executeUpdate();
          
        // closing statement
        pstmt.close();
		
        return price;
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }
  
  public String deposit( String acc_id, String passw, String acc_type, String amount)
  {
    try {
		System.out.println("Transaction = " + computer);
		
		// get given item price from item table
		int price = find(computer);
	
		// record the customer info to the customer table
		insertToCustomer( computer, name, address, payment, price);
        //binding input parameter to TRANSACTION table      
   
		PreparedStatement pstmt = conn.prepareStatement("insert into transaction (item, custom, price) values(?, ?, ?)" );
       
		pstmt.setString(1, computer );
		pstmt.setString(2, name );
		pstmt.setInt(3, price );
		
        // Execute the SQL, ResultSet is row(s) of data returned by database query
		int ins=pstmt.executeUpdate();
          
        // closing statement
        pstmt.close();
		
        return price;
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }
	
  public String withdraw( String acc_id, String passw, String acc_type, String amount)
  {
    try {
		System.out.println("Transaction = " + computer);
		
		// get given item price from item table
		int price = find(computer);
	
		// record the customer info to the customer table
		insertToCustomer( computer, name, address, payment, price);
        //binding input parameter to TRANSACTION table      
   
		PreparedStatement pstmt = conn.prepareStatement("insert into transaction (item, custom, price) values(?, ?, ?)" );
       
		pstmt.setString(1, computer );
		pstmt.setString(2, name );
		pstmt.setInt(3, price );
		
        // Execute the SQL, ResultSet is row(s) of data returned by database query
		int ins=pstmt.executeUpdate();
          
        // closing statement
        pstmt.close();
		
        return price;
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }
  
  public String balance( String acc_id, String passw, String acc_type)
  {
    try {
	//	System.out.println(" = " + computer);
		
		// get given item price from item table
		int price = find(computer);
	
		// record the customer info to the customer table
		insertToCustomer( computer, name, address, payment, price);
        //binding input parameter to TRANSACTION table      
   
		PreparedStatement pstmt = conn.prepareStatement("insert into transaction (item, custom, price) values(?, ?, ?)" );
       
		pstmt.setString(1, computer );
		pstmt.setString(2, name );
		pstmt.setInt(3, price );
		
        // Execute the SQL, ResultSet is row(s) of data returned by database query
		int ins=pstmt.executeUpdate();
          
        // closing statement
        pstmt.close();
		
        return price;
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }	  
  
  
	  // To record the customer info to the customer table
  public void insertToCustomer( String computer, String name, String address, String payment, int price) throws Exception
  {
    try {
		System.out.println("Transaction = " + computer);
   
   		// Binding input parameters to CUSTOMER table
		PreparedStatement pstmt1 = conn.prepareStatement("insert into customer (custom, item, address, payment, price) values(?, ?, ?, ?, ?)" );
       
		pstmt1.setString(1, name );
		pstmt1.setString(2, computer );
		pstmt1.setString(3, address );
		pstmt1.setString(4, payment );
		pstmt1.setInt(5, price );
        // Execute the SQL, ResultSet is row(s) of data returned by database query
		int ins1 = pstmt1.executeUpdate();
          
        // closing statement
        pstmt1.close();
		
    }
    catch (Exception e) {
        throw new Exception("Error: "+ e.getMessage() );
    }
  }
  
*/  
  // It closes the connection of database 
  public void close() throws Exception
  {
    try {
      conn.close();
      System.out.println("Connection Closed");
    } 
    catch (Exception e) 
    {
      throw new Exception("Error in closing dbase: " + e.getMessage());
    }
  }
}

