/* myDatabase.java
 * This class provides methods to access the Oracle database via JDBC
 * API:  void open()
 *    personInfo find(String word) 
 *    void close ()
 * Exceptions are thrown.
 */

import java.sql.*;
import java.util.Properties;

class myDatabase {

  private Connection conn;

  public void open() throws Exception
  {
    try {
      //Class.forName("oracle.jdbc.driver.OracleDriver");
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      conn = DriverManager.getConnection
          ("jdbc:odbc:persondb", "", "");
      System.out.println("Connection Open");
		} catch (Exception e) { 
			throw new Exception("Error connection:" + e.getMessage());
		}
  }

  public personInfo find(String word) throws Exception
  {
    try {
      System.out.println("name passed = " + word);
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement("select * from persontable where NAME = ?");
      pstmt.setString(1,word);
     // Execute the SQL, ResultSet is row(s) of data returned by database query
      ResultSet rs = pstmt.executeQuery();
      // return the fields of the first row of the result set
		personInfo p = null;
      if( rs.next() )
			p = new personInfo(rs.getString("NAME"), rs.getInt("AGE"),
              rs.getString("OCCUP"), rs.getString("STYLE"));

      // closing statement
      pstmt.close();
      return p;
    }
    catch (Exception e) {
	 	throw new Exception("Error: "+ e.getMessage() );
    }
  }

  public String XMLfind(String word) throws Exception
  {
    String resultStr = "<persons>\n";
    try {
      // binding input parameters to SQL call
      Statement stmt = conn.createStatement();
      String query = "select * from persontable";
      if(!word.equals(""))
        query += " where name like '%"+ word +"%'";
      ResultSet rs = stmt.executeQuery(query);
      ResultSetMetaData rsmd = rs.getMetaData();

      int numCols = rsmd.getColumnCount();
      int i = 0;
      String[] fieldNames = new String[numCols+1];

      // get column header info
      for (i=1; i <= numCols; i++)
        fieldNames[i] = rsmd.getColumnLabel(i);

      while (rs.next()){
        resultStr += "<person>\n";
        for (i=1; i <= numCols; i++) 
            resultStr += "<" + fieldNames[i] + ">"+ rs.getString(i) + "</" + fieldNames[i] +">\n";
        resultStr += "</person>\n";
      }
      rs.close();
      resultStr += "</persons>\n";
      return resultStr;
    }
    catch (Exception e) {
	 	throw new Exception("Error: "+ e.getMessage() );
    }
  }

  public void close() throws Exception
  {
    try {
      conn.close();
      System.out.println("Connection Closed");
    } catch (Exception e) {
			throw new Exception("Error in closing dbase: " + e.getMessage());
	}
  }
}
